# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.kz> 
__version__ = '$Revision: 1.2 $'[11:-2]

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFCore.CatalogTool import CatalogTool
from Products.CMFCore.CMFCorePermissions import View, ManagePortal

class ForumCatalog(CatalogTool):
    """ """
    meta_type = 'ForumCatalog'

    id = 'forum_catalog'

    security = ClassSecurityInfo()

    security.declarePublic( 'enumerateIndexes' )
    def enumerateIndexes( self ):
        return ( ('id', 'FieldIndex'),
                 ('title', 'FieldIndex'),
                 ('Creator', 'FieldIndex'),
                 ('created', 'DateIndex'),
                 ('modified', 'DateIndex'),
                 ('allowedRolesAndUsers', 'KeywordIndex'),
                 ('review_state', 'FieldIndex'),
                 ('last_reply_user', 'FieldIndex'),
                 ('topic_type', 'FieldIndex'),
                 ('sticky_flag', 'FieldIndex'),
                 )
    
    security.declarePublic( 'enumerateColumns' )
    def enumerateColumns( self ):
        return ( 'sticky_flag',
                 'description',
                 'modified',
                 'Creator',
                 'title',
                 'review_state',
                 'replies',
                 'last_reply_user'
                 )

InitializeClass(ForumCatalog)


def addForumCatalog(self):
    ob = ForumCatalog()
    self._setObject(ob.getId(), ob)

    return ob
