# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz>
__version__ = '$Revision: 1.12 $'[11:-2]

import random, traceback
from Globals import InitializeClass
from Acquisition import aq_parent, aq_base
from Products.Archetypes.public import *
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.config import TOOL_NAME as ARCHETYPE_TOOL
from Products.Archetypes.interfaces.referenceable import IReferenceable

from config import *
from utils import forum_parser
from ForumTopic import ForumTopic

class ForumContentTopic(ForumTopic):
    """ """
    meta_type = 'ForumContentTopic'
    archetype_name = 'Forum Content Topic'

    global_allow = 0
    filter_content_types = 1
    allowed_content_types = []

    security = ClassSecurityInfo()

    topic_type = 1

    content_uid = 0
    content_path = ''

    security.declarePrivate('initializeArchetype')
    def initializeArchetype(self, **kwargs):
        """ """
        content_uid = kwargs.get('content_uid', self.content_uid)
        content_path = kwargs.get('content_path', self.content_path)

        if not content_uid and not content_path:
            raise ValueError, 'Content link not found'

        if not content_uid:
            ob = self.unrestrictedTraverse(content_path)
            if IReferenceable.isImplementedBy(ob):
                content_uid = ob.UID()
        else:
            ob = getToolByName(self, ARCHETYPE_TOOL).lookupObject(content_uid)

        if not ob:
            raise ValueError, "Can't find content object"
        else:
            kwargs['title'] = ob.Title()
            kwargs['message_icon'] = ob.getTypeInfo().content_icon

        self.content_uid = content_uid
        self.content_path = content_path

        ForumTopic.initializeArchetype(self, **kwargs)

    def _get_content(self):
        if self.content_uid:
            try:
                ob = getToolByName(self, ARCHETYPE_TOOL).lookupObject(self.content_uid)
            except:
                pass

        ob = self.unrestrictedTraverse(self.content_path)
        return ob

    security.declareProtected(View, 'Title')
    def Title(self):
        """ """
        try:
            ob = self._get_content()
            return ob.Title()
        except:
            return '<b>Broken content!!!</b>'

    security.declareProtected(View, 'Content')
    def Content(self, emoticons=1, add_breaks=1, preview=None):
        """ """
        try:
            ob = self._get_content()
            if hasattr(aq_base(ob), 'EditableBody'):
                content = ob.EditableBody()
                text_format = getattr(aq_base(ob), 'text_format', 'text/plain')
                if text_format != self.text_format:
                    self.text_format = text_format
                return forum_parser(
                    self, content, emoticons, add_breaks, preview, text_format=text_format)
            elif hasattr(aq_base(ob), 'getText'):
                content = ob.getText()
                text_format = getattr(aq_base(ob), 'text_format', 'text/plain')
                if text_format != self.text_format:
                    self.text_format = text_format
                return forum_parser(
                    self, content, emoticons, add_breaks, preview, text_format=text_format)

            content = 'original: [url=%s urltitle=%s][/url]'% (
                getattr(aq_base(ob), 'description', ''), ob.absolute_url(),
                getattr(aq_base(ob), 'title', ''))
            return forum_parser(self, content, emoticons, add_breaks, preview)
        except:
            traceback.print_exc()
            return "Can't found content"

    security.declareProtected(View, 'CookedBody')
    CookedBody = Content

    security.declareProtected(View, 'EditableBody')
    def EditableBody(self):
        """ """
        try:
            ob = self._get_content()
            try:
                return ob.EditableBody()
            except:
                return ob.getText()
        except:
            return self.Content()


registerType(ForumContentTopic)
InitializeClass(ForumContentTopic)
