# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz> 
__version__ = '$Revision: 1.9 $'[11:-2]

import traceback
from Globals import InitializeClass
from Products.Archetypes.public import *
from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent
from config import plone_ver

schema = BaseSchema

default_forums = {
    'members': ({'title': 'Member Test Forum'}, 'members'),
    'public': ({'title': 'Public Test Forum'}, 'public1'),
    }

class ForumFolder(OrderedBaseFolder):
    """ """
    meta_type = 'ForumFolder'
    archetype_name = 'Forum Folder'

    schema = BaseSchema + Schema((
        StringField('title', required=1, default='Discussion Forums',
                    widget=StringWidget(label_msgid='label_title',
                                        description_msgid='help_title',
                                        i18n_domain='plone')),
        StringField('description', default='',
                    widget=TextAreaWidget(label_msgid='label_description',
                                          description_msgid='help_description',
                                          i18n_domain='plone')),
        ))


    allowed_content_types = ['ForumNB', 'ForumFolder']
    content_icon = 'fcFolder_icon.gif'

    _properties = (
        {'id': 'right_slots', 'type': 'lines', 'mode':'rw'},
        )

    if plone_ver == 1:
        actions = (
            {'id': 'view',
             'name': 'View',
             'action': 'forum_folder_view',
             'permissions': (View,)
             },
            )
    else:
        actions = (
            {'id': 'view',
             'name': 'View',
             'action': 'string:$object_url/forum_folder_view',
             'permissions': (View,)
             },
            )

    security = ClassSecurityInfo()

    right_slots = []

    title = 'Discussion Forums'

    def initializeArchetype(self, **kwargs):
        """ """
        OrderedBaseFolder.initializeArchetype(self, **kwargs)

        wtool = self.portal_workflow
        
        pt = self.portal_types.constructContent
        for id, attrs in default_forums.items():
            try:
                pt('ForumNB', self, id, **attrs[0])
                ob = getattr(self, id)
                try:
                    wtool.doActionFor(ob, attrs[1])
                except:
                    pass
            except:
                pass

    security.declarePrivate('upgradeFolder')
    def upgradeFolder(self):
        o = []
        for r in self._objects:
            if r['meta_type'] == 'Forum':
                ob = getattr(self, r['id'])
                if ob.meta_type == 'ForumNB':
                    r['meta_type'] = 'ForumNB'
            o.append(r)
        self._objects = tuple(o)

    def manage_afterDelete(self, item, container):
        OrderedBaseFolder.manage_afterDelete(self, item, container)

        self._copy = 0

    def _notifyOfCopyTo(self, container=None, op=1):
        OrderedBaseFolder._notifyOfCopyTo(self, container, op)

        self._copy = 1

        for ob in self.objectValues():
            ob._notifyOfCopyTo(container, op)

registerType(ForumFolder)
InitializeClass(ForumFolder)
