# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz>
"""
$Id: SizeValidator.py,v 1.4 2003/11/07 12:32:42 fafhrd91 Exp $
"""

from Products.Archetypes.public import *
try:
    from validation.interfaces import ivalidator
    from validation import validation
except ImportError, e:
    from Products.validation import validation
    from Products.validation.interfaces import ivalidator

class SizeValidator:
    __implements__ = (ivalidator,)
    
    def __init__(self, name):
        self.name = name
        
    def __call__(self, value, *args, **kwargs):
        inst = kwargs['instance']

        if self.name == 'checkImageSize':
            size = inst.image_size
        else:
            size = inst.file_size

        if hasattr(value, 'filename') and (size < len(value.read())):
            try:
                value.seek(0)
            except:
                pass
            return 'Max size exceeded.'
        return 1

validation.register(SizeValidator('checkImageSize'))
validation.register(SizeValidator('checkFileSize'))
