# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.kz> 
__version__ = '$Revision: 1.36 $'[11:-2]

import os
from Globals import package_home
from Products.CMFCore.CMFCorePermissions import \
     AddPortalContent, ModifyPortalContent, ManagePortal

_zptdir = os.path.join(package_home(globals()), 'zpt')

from Products.CMFPlone import Portal
if Portal.__version__ > '1.0':
    plone_ver = 2
else:
    plone_ver = 1

ADD_CONTENT_PERMISSION = AddPortalContent
PROJECTNAME = "CMFBoard"
SKINS_DIR = 'skins'

discussionSkin = 'cmfboard/fcDiscussion'

slots = (
    'here/forumRejected_slot/macros/rejectedBox',
    'here/forumSubmitted_slot/macros/submittedBox',
    )

GLOBALS = globals()

indexes = (
    ('forum_email', 'FieldIndex'),
    )

global_properties = (
    ('quickreply_form', 'string', 'here/forum_quickreply_form/macros/edit_form'),
    ('forum_page_size', 'int', 20),
    ('topic_page_size', 'int', 20),
    ('unique_emails', 'boolean', 0),
    )

memberData_properties = (
    ('fc_posts', 'int', 0),
    ('fc_autosubscribe', 'boolean', 0),
    ('fc_emailtome', 'boolean', 1), # can other members email to me
    ('fc_forum_vm', 'string', 'flat'), # view mode for forum
    ('fc_topic_vm', 'string', 'flat'), # view mode for topic
    ('fc_topic_sm', 'string', 'older_first'), # sort mode for topic
    ('fc_internal_data', 'string', ''),

    ('location', 'string', ''),
    ('occupation', 'string', ''),
    ('interests', 'string', ''),
    ('homepage', 'string', ''),
    ('timezone', 'string', ''),
    ('signatures', 'lines', []),

    ('im_icq', 'string', ''),
    ('im_jabber', 'string', ''),
    ('im_yahoo', 'string', ''),
    ('im_msn', 'string', ''),
    ('im_aim', 'string', ''),
    ('im_ichat', 'string', ''),

    ('show_email', 'boolean', 0),
    ('show_im', 'boolean', 1),
    ('show_fullname', 'boolean', 0),
    )

topicTypes = {
    1: 'regular',
    2: 'admin',
    3: 'announce',
    }
topicTypeList = topicTypes.keys()

forum_preferences = {
    'id': 'CMFBoard_meber_prefs',
    'appId': 'CMFBoard_member_prefs',
    'name': 'Forum preferences',
    'action': 'string:$portal_url/prefs_contact_info',
    'condition': 'not:object/portal_membership/isAnonymousUser',
    'permission': ('View',),
    'category': 'Member',
    'imageUrl': 'fcForum_icon.gif',
    }

if plone_ver == 1:
    cmfboard_configlet = {
        'id': 'CMFBoard',
        'name': 'CMFBoard setup',
        'action': 'string:$portal_url/prefs_cmfboard_form',
        'category': 'global',
        'permission': (ManagePortal,),
        'condition': '',
        }
else:
    cmfboard_configlet = {
        'id': 'CMFBoard',
        'appId': 'CMFBoard',
        'name': 'CMFBoard settings',
        'action': 'string:$portal_url/prefs_cmfboard_form',
        'category': 'Products',
        'permission': (ManagePortal,),
        'imageUrl': 'fcFolder_icon.gif',
        }

discussion_configlet = {
    'id': 'CMFBoard_discussion',
    'appId': 'CMFBoard_discussion',
    'name': 'CMFBoard Discussion tool settings',
    'action': 'string:$portal_url/prefs_discussion_tool_form',
    'category': 'Products',
    'permission': ('Manage portal',),
    'imageUrl': 'fcFolder_icon.gif',
    }

forms = {
    'default': {'forum_contact_admin': {'success':'action:view',},
                'forum_contact_admin_form': {'success':'script:forum_contact_admin',
                                             'failure':'forum_contact_admin_form',
                                             'cancel':'action:view',},

                'forum_contact_member': {'success':'action:view',},
                'forum_contact_member_form': {'success':'script:forum_contact_member',
                                              'failure':'forum_contact_member_form',
                                              'cancel':'action:view',},

                'forum_send_message': {'success':'action:view',},
                'forum_send_message_form': {'success':'script:forum_send_message',
                                            'failure':'forum_send_message_form',
                                            'cancel':'action:view',},

                'forum_add_topic': {'success':'action:view',},
                'forum_add_topic_form': {'success':'script:forum_add_topic',
                                         'failure':'forum_add_topic_form',
                                         'preview':'forum_add_topic_form',
                                         'cancel':'action:view',
                                         },

                'forum_add_poll': {'success':'action:view',},
                'forum_add_poll_form': {'success':'script:forum_add_poll',
                                        'failure':'forum_add_poll_form',
                                        'preview':'forum_add_poll_form',
                                        'cancel':'action:view',
                                        },
                
                'forum_add_announcement': {'success':'action:view',},
                'forum_add_announcement_form': {'success':'script:forum_add_announcement',
                                                'failure':'forum_add_announcement_form',
                                                'preview':'forum_add_announcement_form',
                                                'cancel':'action:view',
                                                },
                'forum_reply_form': {'success':'script:forum_add_reply',
                                     'failure':'forum_reply_form',
                                     'preview':'forum_reply_form',
                                     'cancel':'action:view',
                                     },
                
                'discussion_tool_edit_form': {'success': 'script:discussion_tool_edit',
                                              'failure': 'discussion_tool_edit_form'},
                'discussion_tool_edit': {'success': 'action:view',
                                         'failure': 'discussion_tool_edit_form'},

                'discussion_reply_form': {'success':'script:discussion_reply',
                                          'failure':'discussion_reply_form',
                                          'preview':'discussion_reply_form',
                                          'cancel':'action:view',
                                          },
                'discussion_reply': {'success':'action:view',},
                
                'forum_topic': {'success':'script:forum_add_reply',
                                'failure':'forum_topic',
                                'preview':'forum_topic',
                                'cancel':'action:view',
                                },
                'forum_add_reply': {'success':'action:view',},
                
                'forum_message': {'success':'script:forum_add_reply',
                                  'failure':'action:view',
                                  'preview':'forum_message',
                                  'cancel':'action:view',
                                  },
                'forum_message_edit': {'success':'script:forum_content_edit',
                                       'failure':'forum_message_edit',
                                       'preview':'forum_message_edit',
                                       'cancel':'action:preview',
                                       },
                'forum_content_edit': {'success':'forum_topic', },

                'forum_poll_edit': {'success':'script:forum_content_edit',
                                    'failure':'forum_poll_edit',
                                    'preview':'forum_poll_edit',
                                    'cancel':'action:preview',
                                    },

                'forum_change_members_emails':
                { 'success':'script:forum_change_members_emails_set',
                  'failure':'forum_change_members_emails',
                  'cancel':'forum_check_uniques_form',
                  },
                'forum_change_members_emails_set': {'success':'forum_check_uniques_form', },
                
                'prefs_contact_info': {'success':'script:prefs_contact_info_set',
                                       'failure':'prefs_contact_info',},
                'prefs_contact_info_set': {'success':'prefs_contact_info',},
                
                'prefs_cmfboard_form': {'success':'script:prefs_cmfboard_set',
                                        'failure':'prefs_cmfboard_form',},
                'prefs_cmfboard_set': {'success':'prefs_cmfboard_form',},
                },
    'forummessage': {'forum_content_edit': {'success':'action:preview'},},
    'forumtopic': {'forum_content_edit': {'success':'action:preview'},},
    'forumpoll': {'forum_content_edit': {'success':'action:preview'},},
    }

validators = {
    'forum_topic': ['validate_add_reply'],
    'forum_message': ['validate_add_reply'],
    'forum_message_edit': ['validate_message_edit'],
    'forum_poll_edit': ['validate_message_edit'],
    'forum_add_poll_form': ['validate_add_poll'],
    'forum_add_topic_form': ['validate_add_reply'],
    'forum_add_announcement_form': ['validate_add_reply'],
    'forum_contact_admin_form': ['validate_contact_admin'],
    'forum_contact_member_form': ['validate_contact_admin'],
    'forum_send_message_form': ['validate_contact_admin'],
    'forum_reply_form': ['validate_add_reply'],
    'discussion_reply_form': ['validate_discussion_reply'],
    'forum_change_members_emails': ['validate_change_members_emails'],
    'prefs_contact_info': ['validate_prefs_contact'],
    'prefs_cmfboard_form': ['validate_prefs_cmfboard'],
    }
